#!/usr/bin/perl -w

use Tk;
use lib "$ENV{HOME}/prog/perl/module";
use lib "/usr/local/share/ADS3kp";
use ADS3kp;
use Tk::NoteBook;

$ads = new ADS3kp;
$a = "";
$Author="";
$Date="";
$Rev="";

$ver = "Ver $Rev: 57 $a Author $Author: vlbi $a \n Date $Date: 2016-08-22 19:02:15 +0900 (Mon, 22 Aug 2016) $a,";


# ㉭≰≤㉳≦≣㉳㒲咤扽咣E
$sub_w = MainWindow->new();
$sub_w->geometry( "400x80" );
$sub_w->title("ADS3000plus Setting tool ");
#$sub_w->optionAdd( '*font' => '≴≷㒡 10' );
$sub_w->Label( -text => "$ver", -relief => 'flat' , -background => 'lightblue')->pack(  -side => "bottom", -anchor => 'center' ,-padx => 3);

$sub_w->Label( -text => "Host IP Address", -relief => 'flat' , -background => 'yellow')->pack(  -side => "left", -anchor => 'center' ,-padx => 3);

$opt_IP = $sub_w->Optionmenu(-variable=>\$Pc_ip)->pack( -side => "left" ,-padx => 3,-anchor => 'center' );

#$opt_IP ->addOptions("ads3kp-c");
#$opt_IP ->addOptions("ads3kp-e");
#$opt_IP ->addOptions("ads3000-kog11");
#$opt_IP ->addOptions("ads3kp-a");
#$opt_IP ->addOptions("ads3kp-b");
#$opt_IP ->addOptions("ads3kp-d");

$SDIR = "/usr/local/share/ADS3kp";
$PC_FILE = "host.txt";
open (FILE,"<$SDIR/$PC_FILE") || 
    open (FILE, $PC_FILE ) || die("Can't open HOST file($PC_FILE): $!");
while (my $line = <FILE>){
  chomp($line);
  $opt_IP ->addOptions($line);
}
close (FILE);

# 咤㉳扽蒡咣E
$sub_w->Button( -text => "LOGIN!", -command => \&onButton)->pack( -side => "right" ,-padx => 3, -anchor => 'center');

# ㉡≤㉳㉫㉼咢璡
MainLoop();

sub ReadData1_0{

	$pps = 0;
	$pdata = 0;
	
    @mode = ();
    @mode = $ads->ReadMode();
    for($i=0; $i<@mode; $i++){
		$mode[$i]=~ s/\s+//g;
    }
    $mode1 = $mode[0];
	$mode2 = $mode[1];
	$mode3 = $mode[2];
	$mode4 = $mode[3];
	
    @offs = ();
    @offs = $ads->ReadOffs();
    for($i=0; $i<@offs; $i++){
		$offs[$i]=~ s/\s+//g;
    }
    $offs1 = $offs[0];
	$offs2 = $offs[1];
	$offs3 = $offs[2];
	$offs4 = $offs[3];

    @gain = ();
    @gain = $ads->ReadGain();
    for($i=0; $i<@gain; $i++){
		$gain[$i]=~ s/\s+//g;
    }
    $gain1 = $gain[0];
	$gain2 = $gain[1];
	$gain3 = $gain[2];
	$gain4 = $gain[3];
    
    @cicgain = ();
    @cicgain = $ads->ReadCicgain();
    for($i=0; $i<@cicgain; $i++){
		$cicgain[$i]=~ s/\s+//g;
    }

    $cicgain1 = $cicgain[0].$cicgain[1].$cicgain[2].$cicgain[3];
    $cicgain2 = $cicgain[4].$cicgain[5].$cicgain[6].$cicgain[7];
    $cicgain3 = $cicgain[8].$cicgain[9].$cicgain[10].$cicgain[11];
    $cicgain4 = $cicgain[12].$cicgain[13].$cicgain[14].$cicgain[15];

    @bbcgain = ();
    @bbcgain_temp = ();
    @bbcgain_name = ();
    @bbcgain_temp = $ads->ReadBbcgain();
    for($i=0; $i<@bbcgain_temp; $i++){
		$bbcgain_temp[$i]=~ s/\s+//g;
	    if($bbcgain_temp[$i] eq "7"){ $bbcgain_name[$i] ="7:+7dB"; $bbcgain[$i]="7";}
	    elsif($bbcgain_temp[$i] eq "6"){ $bbcgain_name[$i] ="6:+6dB"; $bbcgain[$i]="6";}
	    elsif($bbcgain_temp[$i] eq "5"){ $bbcgain_name[$i] ="5:+5dB"; $bbcgain[$i]="5";}
	    elsif($bbcgain_temp[$i] eq "4"){ $bbcgain_name[$i] ="4:+4dB"; $bbcgain[$i]="4";}
	    elsif($bbcgain_temp[$i] eq "3"){ $bbcgain_name[$i] ="3:+3dB"; $bbcgain[$i]="3";}
	    elsif($bbcgain_temp[$i] eq "2"){ $bbcgain_name[$i] ="2:+2dB"; $bbcgain[$i]="2";}
	    elsif($bbcgain_temp[$i] eq "1"){ $bbcgain_name[$i] ="1:+1dB"; $bbcgain[$i]="1";}
	    elsif($bbcgain_temp[$i] eq "0"){ $bbcgain_name[$i] ="0:0dB"; $bbcgain[$i]="0";}
	    elsif($bbcgain_temp[$i] eq "F"){ $bbcgain_name[$i] ="F:-1dB"; $bbcgain[$i]="F";}
	    elsif($bbcgain_temp[$i] eq "E"){ $bbcgain_name[$i] ="E:-2dB"; $bbcgain[$i]="E";}
	    elsif($bbcgain_temp[$i] eq "D"){ $bbcgain_name[$i] ="D:-3dB"; $bbcgain[$i]="D";}
	    elsif($bbcgain_temp[$i] eq "C"){ $bbcgain_name[$i] ="C:-4dB"; $bbcgain[$i]="C";}
	    elsif($bbcgain_temp[$i] eq "B"){ $bbcgain_name[$i] ="B:-5dB"; $bbcgain[$i]="B";}
	    elsif($bbcgain_temp[$i] eq "A"){ $bbcgain_name[$i] ="A:-6dB"; $bbcgain[$i]="A";}
	    elsif($bbcgain_temp[$i] eq "9"){ $bbcgain_name[$i] ="9:-6dB"; $bbcgain[$i]="9";}
	    elsif($bbcgain_temp[$i] eq "8"){ $bbcgain_name[$i] ="8:-6dB"; $bbcgain[$i]="8";}
    }
    
    $bbcgain1 = $bbcgain[0];$bbcgain_name1 = $bbcgain_name[0];
	$bbcgain2 = $bbcgain[1];$bbcgain_name2 = $bbcgain_name[1];
	$bbcgain3 = $bbcgain[2];$bbcgain_name3 = $bbcgain_name[2];
	$bbcgain4 = $bbcgain[3];$bbcgain_name4 = $bbcgain_name[3];
    $bbcgain5 = $bbcgain[4];$bbcgain_name5 = $bbcgain_name[4];
    $bbcgain6 = $bbcgain[5];$bbcgain_name6 = $bbcgain_name[5];
    $bbcgain7 = $bbcgain[6];$bbcgain_name7 = $bbcgain_name[6];
    $bbcgain8 = $bbcgain[7];$bbcgain_name8 = $bbcgain_name[7];
    $bbcgain9 = $bbcgain[8];$bbcgain_name9 = $bbcgain_name[8];
    $bbcgain10 = $bbcgain[9];$bbcgain_name10 = $bbcgain_name[9];
    $bbcgain11 = $bbcgain[10];$bbcgain_name11 = $bbcgain_name[10];
    $bbcgain12 = $bbcgain[11];$bbcgain_name12 = $bbcgain_name[11];
    $bbcgain13 = $bbcgain[12];$bbcgain_name13 = $bbcgain_name[12];
    $bbcgain14 = $bbcgain[13];$bbcgain_name14 = $bbcgain_name[13];
    $bbcgain15 = $bbcgain[14];$bbcgain_name15 = $bbcgain_name[14];
    $bbcgain16 = $bbcgain[15];$bbcgain_name16 = $bbcgain_name[15];
    
    $mode_vsisel=0;

    #@vsisel = ();
    #@vsisel = $ads->ReadVsisel();
    #for($i=0; $i<@vsisel; $i++){
	#	$vsisel[0]=~ s/\s+//g;
	#	if($vsisel[0] == 0){
	#	    $mode_vsisel_name="0:DBBC";
	#	}elsif($vsisel[0] == 1){
	#	    $mode_vsisel_name="1:1Gsps";
	#	}elsif($vsisel[0] == 2){
	#	    $mode_vsisel_name="2:1Gsps";
	#	}elsif($vsisel[0] == 3){
	#	    $mode_vsisel_name="3:1Gsps";
	#	}
    #}
    #$mode_vsisel=$vsisel[0];
    
}

sub ReadData1_1{
    
    @adcch = ();
    @adcch = $ads->ReadAdcchsel();
    @adcch = reverse(@adcch);
    for($i=0; $i<@adcch; $i++){
		$adcch[$i]=~ s/\s+//g;
    }
    $adcchsel = $adcch[0];
	if($adcchsel eq 0){ $adcchsel_name="0:off";}
	elsif( $adcchsel eq 1) { $adcchsel_name="1:1ch";}
	elsif( $adcchsel eq 2) { $adcchsel_name="2:2ch";}
	elsif( $adcchsel eq 3) { $adcchsel_name="3:3ch";}
	elsif( $adcchsel eq 4) { $adcchsel_name="4:4ch";}
    
    @adcoffs = ();
    @adcoffs = $ads->ReadAdcoffs();
    #@adcoffs = reverse(@adcoffs);
    for($i=0; $i<@adcoffs; $i++){
		$adcoffs[$i]=~ s/\s+//g;
    }
    $adcoffs = $adcoffs[0];
    
    @adcgain = ();
    @adcgain = $ads->ReadAdcgain();
    for($i=0; $i<@adcgain; $i++){
		$adcgain[$i]=~ s/\s+//g;
    }
    $adcgain = $adcgain[0];

	$list_bit->configure( -state => 'normal');
	$list_bit->delete( '1.0', 'end' );
	$list_bit->configure( -state => 'disabled');
}

sub ReadData1_2{

    @sigchk = ();
    @sigchk = $ads->SigCheck();
    for($i=0; $i<@sigchk; $i++){
		$sigchk[$i]=~ s/\s+//g;
    }
    $sigchk1 = $sigchk[0];
	$sigchk2 = $sigchk[1];
	$sigchk3 = $sigchk[2];

    @rev = ();
    @rev = $ads->Rev();
    for($i=0; $i<@rev; $i++){
		$rev[$i]=~ s/\s+//g;
    }
    $rev1 = $rev[0];
	$rev2 = $rev[1];
	$rev3 = $rev[2];
    
    @ver = ();
    @ver = $ads->Version();
    for($i=0; $i<@ver; $i++){
		$ver[$i]=~ s/\s+//g;
    }
    $ver1 = $ver[0];
	$ver2 = $ver[1];
	$ver3 = $ver[2];
	$ver4 = $ver[3];
}

sub ReadData2{

    @bw = ();
    @bw = $ads->ReadBW();
    for($i=0; $i<@bw; $i++){
		$bw[$i]=~ s/\s+//g;
		if ($bw[$i]==4000000){
		    $bw[$i]=0;
		}elsif($bw[$i]==8000000){
		    $bw[$i]=1;
		}elsif($bw[$i]==16000000){
		    $bw[$i]=2;
		}else{
		    $bw[$i]=3;
		}
    }
# BBC Bandwidth setting, 0:8Msps, 1:16Msps, 2:32Msps, 3:64Msps
    if($bw[0] == 0){ $Bandwidth_name ="0:8Msps"; $Bandwidth=4;}
    elsif($bw[0] == 1){ $Bandwidth_name ="1:16Msps"; $Bandwidth=8;}
    elsif($bw[0] == 2){ $Bandwidth_name ="2:32Msps"; $Bandwidth=16;}
    elsif($bw[0] == 3){ $Bandwidth_name ="3:64Msps"; $Bandwidth=32;}

    @ifin = ();
    @ifin = $ads->ReadFin();
    for($i=0; $i<@ifin; $i++){
		$ifin[$i]=~ s/\s+//g;
    }
# Input channel settting
    $I_channel1 = $ifin[0].$ifin[1].$ifin[2].$ifin[3];
    $I_channel2 = $ifin[4].$ifin[5].$ifin[6].$ifin[7];
    $I_channel3 = $ifin[8].$ifin[9].$ifin[10].$ifin[11];
    $I_channel4 = $ifin[12].$ifin[13].$ifin[14].$ifin[15];

    @ulsb = ();
    @ulsb = $ads->ReadLSB();
    for($i=0; $i<@ulsb; $i++){
		$ulsb[$i]=~ s/\s+//g;
    }
# Output channel settting, 0ӶSB, 1ӭSB, 2Ӥomplex, 3eserve 
    $O_channel1 = $ulsb[0].$ulsb[1].$ulsb[2].$ulsb[3];
    $O_channel2 = $ulsb[4].$ulsb[5].$ulsb[6].$ulsb[7];
    $O_channel3 = $ulsb[8].$ulsb[9].$ulsb[10].$ulsb[11];
    $O_channel4 = $ulsb[12].$ulsb[13].$ulsb[14].$ulsb[15];

    @vsi = ();
    @vsi = $ads->ReadDbbcvsi();

    $vsi[0]=~ s/\s+//g;
    if($vsi[0] eq 0){
		$vsi_name = "0:bit-div-clock-fix";
    }elsif($vsi[0] eq 1){
		$vsi_name = "1:bit-div-clock-variable";
    }elsif($vsi[0] eq 2){
		$vsi_name = "2:channel-div-clock-fix";
    }elsif($vsi[0] eq 3){
		$vsi_name = "3:channel-div-clock-variable";
    }
    $dbbcvsi=$vsi[0];

    @frq = ();
    @frq = $ads->ReadLo();
    for($i=0; $i<@frq; $i++){
		$frq[$i]=~ s/\s+//g;
		$frq[$i]=sprintf("%.2f",$frq[$i]*1.e-6);
    }

    #@Frequency = ();

    #for($r=0; $r<=17; $r++){
	#	push ( @Frequency,(["bbc_d1","1",$r, $frq[$r] ])); # Hz -> MHz * 1.e-6
    	#push ( @Frequency,(["bbc_d1","1",$r])); # Hz -> MHz * 1.e-6
    #}
    
    $Frequency0=$frq[0];$Frequency1=$frq[1];$Frequency2=$frq[2];$Frequency3=$frq[3];
    $Frequency4=$frq[4];$Frequency5=$frq[5];$Frequency6=$frq[6];$Frequency7=$frq[7];
    $Frequency8=$frq[8];$Frequency9=$frq[9];$Frequency10=$frq[10];$Frequency11=$frq[11];
    $Frequency12=$frq[12];$Frequency13=$frq[13];$Frequency14=$frq[14];$Frequency15=$frq[15];
}

sub onButton{

	$host = $Pc_ip;
	$usr = 'root'; # login ID
	$pass = 'redhat'; # Login Passward

	my $login_chk = $ads->SetHost2($host,$usr,$pass);
	
	if ( $login_chk eq 0 ){
	    @ver = ();
	    @ver = $ads->Version();
	    for($i=0; $i<@ver; $i++){
			$ver[$i]=~ s/\s+//g;
			$find=index($ver[$i],":");
			$ver[$i]=substr($ver[$i],$find+1,10);
			$ver[$i]=~ s/\///g;
			#if ($ver[$i]<20090327){
			#    $sub_w->messageBox(
			#        -type => "ok",
			#       -icon => "warning",
			#       -title => "ADS3000plus Setting login",
			#       -message => "Version error");
			#       return;
			#}
	    }	
	}
	if ( $login_chk eq -1 ){
	  # ㉡㒡㉼≸咥≯≹ꉡ
	    $sub_w->messageBox(
	        -type => "ok",
	        -icon => "warning",
	        -title => "ADS3000plus Setting login",
	        -message => "Failed to Connecting to the Host");
	        return;
	}
	else{

		$sub_w->destroy();
		
		#&ReadData1_0;
		#&ReadData1_1;
		#&ReadData1_2;
		#&ReadData2;
		
		# 㒰咥咤≣㉳㒲咤扽咣E
		$mw = MainWindow->new();
		$mw->geometry( "780x540" );
		$mw->title("ADS3000plus Setting : $Pc_ip");
		$mw->optionAdd( '*font' => '≴≷㒡 10' );

		$book = $mw->NoteBook()->pack( -fill=>'both', -expand=>1 );

		$tab0 = $book->add( "Sheet 1", -label=>"level 0");
		$tab1_0 = $book->add( "Sheet 2", -label=>"level 1-0");
		$tab1_1 = $book->add( "Sheet 3", -label=>"level 1-1");
		$tab1_2 = $book->add( "Sheet 4", -label=>"level 1-2");
		$tab2 = $book->add( "Sheet 5", -label=>"level 2");

		# 咦㉼ቮ蒡
		$tab0_freg1 = $tab0->Frame(-relief => 'flat', -borderwidth => 2);
		$tab0_freg2 = $tab0->Frame(-relief => 'flat', -borderwidth => 2);
		
		$tab1_fb0 = $tab1_0->Frame(-relief => 'groove', -borderwidth => 2);
		$tab1_fb1 = $tab1_1->Frame(-relief => 'groove', -borderwidth => 2);
		$tab1_fbit1 = $tab1_1->Frame(-relief => 'flat', -borderwidth => 2);
		$tab1_fbit2 = $tab1_1->Frame(-relief => 'flat', -borderwidth => 2);
		$tab1_fpps = $tab1_0->Frame(-relief => 'flat');
		$tab1_fmode = $tab1_0->Frame(-relief => 'flat');
		$tab1_foffs = $tab1_0->Frame(-relief => 'flat');
		$tab1_fgain = $tab1_0->Frame(-relief => 'flat');
		$tab1_fpdata = $tab1_0->Frame(-relief => 'flat');
		$tab1_fcic = $tab1_0->Frame(-relief => 'flat');
		$tab1_fbbcgain0 = $tab1_0->Frame(-relief => 'flat');
		$tab1_fbbcgain1 = $tab1_0->Frame(-relief => 'flat');
		
		$tab1_fdbbcmode = $tab1_0->Frame(-relief => 'flat');
		$tab1_fadcch = $tab1_1->Frame(-relief => 'flat');
		$tab1_fadc1 = $tab1_1->Frame(-relief => 'flat');
		$tab1_fadc2 = $tab1_1->Frame(-relief => 'flat');
		
		
		$tab1_frev = $tab1_2->Frame(-relief => 'flat');
		$tab1_fversin = $tab1_2->Frame(-relief => 'flat');
		$tab1_fsignal = $tab1_2->Frame(-relief => 'flat');


		$tab2_fb = $tab2->Frame(-relief => 'groove', -borderwidth => 2);
		$tab2_fbw = $tab2->Frame(-relief => 'flat');
		$tab2_fin = $tab2->Frame(-relief => 'flat');
		$tab2_fout = $tab2->Frame(-relief => 'flat');
		$tab2_fvsi = $tab2->Frame(-relief => 'flat');
		$tab2_ffreq1 = $tab2->Frame(-relief => 'flat');
		$tab2_ffreq2 = $tab2->Frame(-relief => 'flat');
		
		# 咦㉼āE咣E
		$tab0_freg1->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab0_freg2->pack(-side => "top", -padx => 5, -anchor => 'nw');

		$tab1_fb0->pack(-side => "right", -fill => "y" );
		$tab1_fpps->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		$tab1_fmode->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_foffs->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fgain->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fpdata->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fcic->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fbbcgain0->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fbbcgain1->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fdbbcmode->pack(-side => "top", -padx => 5, -anchor => 'nw');
		
		$tab1_fb1->pack(-side => "right", -fill => "y" , -padx => 5, -pady => 5);
		$tab1_fadcch->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		$tab1_fadc1->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		$tab1_fadc2->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fbit1->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab1_fbit2->pack(-side => "top", -padx => 5, -anchor => 'nw');
		
		$tab1_fsignal->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		$tab1_frev->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		$tab1_fversin->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		
		$tab2_fb->pack(-side => "right", -fill => "y" );
		$tab2_fbw->pack(-side => "top", -padx => 5, -pady => 5, -anchor => 'nw');
		$tab2_fin->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab2_fout->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab2_fvsi->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab2_ffreq1->pack(-side => "top", -padx => 5, -anchor => 'nw');
		$tab2_ffreq2->pack(-side => "top", -padx => 5, -anchor => 'nw');

		$tab0_freg1->Label( -text => "regs", -relief => 'flat', -background => 'yellow')->pack( -side => "left", -anchor => 'nw' , -padx => 3,  -pady => 5);
		$opt_reg = $tab0_freg1->Optionmenu(-variable=>\$Regs)->pack( -side => "left", -pady => 3, -padx => 3, -anchor => 'nw' );
		$opt_reg->addOptions(["CPU"=>1],["ADC"=>2],["FPGA1"=>3],["FPGA2"=>4],["CONFIG"=>5]);
		$tab0_freg1->Button( -text => "DISP", -command => \&onDispReg)->pack( -side => "left", -pady => 3, -padx => 3, -anchor => 'nw');
		$list_regs  = $tab0_freg2->Scrolled( 'Text', -scrollbars => 'e', -wrap => 'none' )->pack(-expand => 1, -fill => 'both');
		#$list->delete( '1.0', 'end' );
		#$list->insert('end',"yuka");
		#$list->configure( -state => 'disabled');
				
		$tab1_fb0->Button( -text => "UPDATE", -command => \&onUpdate1_0)->pack( -pady => 20, -padx => 3, -anchor => 'center');
		$tab1_fb0->Button( -text => "RELOAD", -command => \&onReLoad1_0)->pack( -padx => 3, -anchor => 'center');

		$tab1_fpps->Label( -text => "1pps_sync", -relief => 'flat', -background => 'yellow')->pack( -side => "left", -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab1_fpps->Checkbutton( -text => "1pps_sync ",-variable => \$pps )->pack(  -side => "left",-anchor => 'nw', -pady => 5 );

		$tab1_fmode->Label( -text => "mode [10->DBBC, 8->TVG1024, 9->TVG2048]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab1_fmode->Label( -text => "mode ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$tab1_fmode->Label( -text => "1:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fmode->Entry( -background => 'white', -textvariable => \$mode1 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fmode->Label( -text => "2:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fmode->Entry( -background => 'white', -textvariable => \$mode2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fmode->Label( -text => "3:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fmode->Entry( -background => 'white', -textvariable => \$mode3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fmode->Label( -text => "4:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fmode->Entry( -background => 'white', -textvariable => \$mode4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);

		$tab1_foffs->Label( -text => "offs [0x00-0xFF]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab1_foffs->Label( -text => "offs ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$tab1_foffs->Label( -text => "1:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_foffs->Entry( -background => 'white', -textvariable => \$offs1 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_foffs->Label( -text => "2:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_foffs->Entry( -background => 'white', -textvariable => \$offs2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_foffs->Label( -text => "3:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_foffs->Entry( -background => 'white', -textvariable => \$offs3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_foffs->Label( -text => "4:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_foffs->Entry( -background => 'white', -textvariable => \$offs4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);

		$tab1_fgain->Label( -text => "gain [0-7; 2^NUM]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab1_fgain->Label( -text => "gain ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$tab1_fgain->Label( -text => "1:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fgain->Entry( -background => 'white', -textvariable => \$gain1 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fgain->Label( -text => "2:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fgain->Entry( -background => 'white', -textvariable => \$gain2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fgain->Label( -text => "3:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fgain->Entry( -background => 'white', -textvariable => \$gain3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fgain->Label( -text => "4:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fgain->Entry( -background => 'white', -textvariable => \$gain4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);

		$tab1_fpdata->Label( -text => "pdata", -relief => 'flat', -background => 'yellow')->pack( -side => "left", -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab1_fpdata->Checkbutton( -text => "pdata ", -variable => \$pdata )->pack(  -side => "left",-anchor => 'nw', -pady => 5 );

		$tab1_fcic->Label( -text => "Input cicgain settting [0->1, 1->2, 2->4, 3->8]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab1_fcic->Label( -text => "cicgain")->pack( -side => "left",-anchor => 'nw', -pady => 5 );
		$tab1_fcic->Entry( -background => 'white', -textvariable => \$cicgain1 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fcic->Entry( -background => 'white', -textvariable => \$cicgain2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fcic->Entry( -background => 'white', -textvariable => \$cicgain3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab1_fcic->Entry( -background => 'white', -textvariable => \$cicgain4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		
		$tab1_fbbcgain0->Label( -text => "Input bbcgain settting [-6~+6dB]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' , -pady => 3);
		$opt_bbcgain0 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain1, -textvariable=>\$bbcgain_name1)->pack( -side => "left",-anchor => 'nw',  -pady => 3);
		$opt_bbcgain0->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain1 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain2, -textvariable=>\$bbcgain_name2)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain1->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain2 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain3, -textvariable=>\$bbcgain_name3)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain2->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain3 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain4, -textvariable=>\$bbcgain_name4)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain3->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain4 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain5, -textvariable=>\$bbcgain_name5)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain4->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain5 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain6, -textvariable=>\$bbcgain_name6)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain5->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain6 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain7, -textvariable=>\$bbcgain_name7)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain6->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain7 = $tab1_fbbcgain0->Optionmenu(-variable=>\$bbcgain8, -textvariable=>\$bbcgain_name8)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain7->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
	
		$opt_bbcgain8 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain9, -textvariable=>\$bbcgain_name9)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain8->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain9 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain10, -textvariable=>\$bbcgain_name10)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain9->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain10 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain11, -textvariable=>\$bbcgain_name11)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain10->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain11 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain12, -textvariable=>\$bbcgain_name12)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain11->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain12 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain13, -textvariable=>\$bbcgain_name13)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain12->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain13 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain14, -textvariable=>\$bbcgain_name14)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain13->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain14 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain15, -textvariable=>\$bbcgain_name15)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain14->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);
		$opt_bbcgain15 = $tab1_fbbcgain1->Optionmenu(-variable=>\$bbcgain16, -textvariable=>\$bbcgain_name16)->pack( -side => "left",-anchor => 'nw' ,  -pady => 3);
		$opt_bbcgain15->addOptions(["7:+7dB"=>7],["6:+6dB"=>6],["5:+5dB"=>5],["4:+4dB"=>4],["3:+3dB"=>3],["2:+2dB"=>2],["1:+1dB"=>1],["0:0dB"=>0],["F:-1dB"=>F],["E:-2dB"=>E],["D:-3dB"=>D],["C:-4dB"=>C],["B:-5dB"=>B],["A:-6dB"=>A],["9:-6dB"=>9],["8:-6dB"=>8]);

		$tab1_fdbbcmode->Label( -text => "Setting of Sampling Mode", -relief => 'flat' , -background => 'yellow')->pack( -side => "left", -anchor => 'nw' , -padx => 5, -pady => 5 );
		#$tab1_fdbbcmode->Label( -text => "vsisel ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		#$tab1_fdbbcmode->Label( -text => "1", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw', -pady => 5, -padx => 10 );
		#$opt_dbbc = $tab1_fdbbcmode->Optionmenu(-variable=>\$mode_vsisel, -textvariable=>\$mode_vsisel_name)->pack( -side => "left",-anchor => 'nw' );
		#$opt_dbbc->addOptions(["0:DBBC"=>0],["1:1Gsps"=>1],["2:1Gsps"=>2],["3:1Gsps"=>3]);
		$tab1_fdbbcmode->Checkbutton( -text => "vsisel ",-variable => \$mode_vsisel )->pack(  -side => "left",-anchor => 'nw', -pady => 5 );

		$tab1_fadcch->Label( -text => "ADC Channel Selector", -relief => 'flat' , -background => 'yellow')->pack(  -anchor => 'nw' ,-padx => 5, -pady => 5 );
		$tab1_fadcch->Label( -text => "adcchsel")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$opt_adcch = $tab1_fadcch->Optionmenu(-variable=>\$adcchsel, -textvariable=>\$adcchsel_name)->pack( -side => "left",-anchor => 'nw' );
		$opt_adcch->addOptions(["0:off"=>0],["1:1ch"=>1],["2:2ch"=>2],["3:3ch"=>3],["4:4ch"=>4]);

		$tab1_fadc1->Label( -text => "Input adcoffs settting [0X00~0XFF]", -relief => 'flat', -background => 'yellow')->pack(  -anchor => 'nw' , -padx => 5,  -pady => 5);
		$tab1_fadc1->Label( -text => "adcgain External Offset")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		#$tab1_fadc1->Label( -text => "1:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fadc1->Entry( -background => 'white', -textvariable => \$adcoffs ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		#$tab1_fadc1->Label( -text => "2:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		#$tab1_fadc1->Entry( -background => 'white', -textvariable => \$adcoffs2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		#$tab1_fadc1->Label( -text => "3:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		#$tab1_fadc1->Entry( -background => 'white', -textvariable => \$adcoffs3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		#$tab1_fadc1->Label( -text => "4:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		#$tab1_fadc1->Entry( -background => 'white', -textvariable => \$adcoffs4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		
		$tab1_fadc2->Label( -text => "Input adcgain settting [0X00~0XFF]", -relief => 'flat', -background => 'yellow')->pack(  -anchor => 'nw' , -padx => 3,  -pady => 3);
		$tab1_fadc2->Label( -text => "adcgain External Gain")->pack( -side => "left",-anchor => 'nw', -pady => 5 );
		#$tab1_fadc2->Label( -text => "1:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		$tab1_fadc2->Entry( -background => 'white', -textvariable => \$adcgain ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		#$tab1_fadc2->Label( -text => "2:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		#$tab1_fadc2->Entry( -background => 'white', -textvariable => \$adcgain2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		#$tab1_fadc2->Label( -text => "3:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		#$tab1_fadc2->Entry( -background => 'white', -textvariable => \$adcgain3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		#$tab1_fadc2->Label( -text => "4:", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 10);
		#$tab1_fadc2->Entry( -background => 'white', -textvariable => \$adcgain4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);

		$tab1_fbit1->Label( -text => "bit_hist", -relief => 'flat', -background => 'yellow')->pack( -side => "left", -anchor => 'nw' , -padx => 3,  -pady => 5);
		$opt_bit = $tab1_fbit1->Optionmenu(-variable=>\$Bithistch)->pack( -side => "left", -pady => 3, -padx => 3, -anchor => 'nw' );
		$opt_bit->addOptions(["1:1ch"=>1],["2:2ch"=>2],["3:3ch"=>3],["4:4ch"=>4]);
		$tab1_fbit1->Button( -text => "DISP", -command => \&onDispBit)->pack( -side => "left", -pady => 3, -padx => 3, -anchor => 'nw');
		$list_bit  = $tab1_fbit2->Scrolled( 'Text', -scrollbars => 'e', -wrap => 'none' )->pack(-side => "bottom",-expand => 1, -fill => 'both');


		$tab1_fb1->Button( -text => "UPDATE", -command => \&onUpdate1_1)->pack( -pady => 20, -padx => 3, -anchor => 'center');
		$tab1_fb1->Button( -text => "RELOAD", -command => \&onReLoad1_1)->pack( -padx => 3, -anchor => 'center');
		
		$tab1_fsignal->Label( -text => "-signalcheck-", -relief => 'flat' )->pack( -anchor => 'w');
		$tab1_fsignal->Label( -textvariable => \$sigchk1 )->pack( -anchor => 'w');
		$tab1_fsignal->Label( -textvariable => \$sigchk2 )->pack( -anchor => 'w');
		$tab1_fsignal->Label( -textvariable => \$sigchk3 )->pack( -anchor => 'w');
		
		$tab1_frev->Label( -text => "-rev-", -relief => 'flat')->pack( -anchor => 'w');
		$tab1_frev->Label( -textvariable => \$rev1 )->pack( -anchor => 'w');
		$tab1_frev->Label( -textvariable => \$rev2 )->pack( -anchor => 'w');
		$tab1_frev->Label( -textvariable => \$rev3 )->pack( -anchor => 'w');
		
		$tab1_fversin->Label( -text => "-version-", -relief => 'flat')->pack( -anchor => 'w');
		$tab1_fversin->Label( -textvariable => \$ver1 )->pack( -anchor => 'w');
		$tab1_fversin->Label( -textvariable => \$ver2 )->pack( -anchor => 'w');
		$tab1_fversin->Label( -textvariable => \$ver3 )->pack( -anchor => 'w');
		$tab1_fversin->Label( -textvariable => \$ver4 )->pack( -anchor => 'w');

		$tab2_fb->Button( -text => "UPDATE", -command => \&onUpdate2)->pack( -pady => 20, -padx => 3, -anchor => 'center');
		$tab2_fb->Button( -text => "RELOAD", -command => \&onReLoad2)->pack( -padx => 3, -anchor => 'center');
		
		$tab2_fbw->Label( -text => "BBC Bandwidth setting", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab2_fbw->Label( -text => "bbc_bw ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$tab2_fbw->Label( -text => "1", -relief => 'ridge')->pack( -side => "left",-anchor => 'nw',  -pady => 5, -padx => 5);
		$opt_channel = $tab2_fbw->Optionmenu(-variable=>\$Bandwidth, -textvariable=>\$Bandwidth_name)->pack( -side => "left",-anchor => 'nw' );
		$opt_channel->addOptions(["0:8Msps"=>4],["1:16Msps"=>8],["2:32Msps"=>16],["3:64Msps"=>32]);

		$tab2_fin->Label( -text => "Input channel settting [0:A/D CH1, 1:A/D CH2, 2:A/D CH3, 3:A/D CH4]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab2_fin->Label( -text => "dbbcin ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$tab2_fin->Entry( -background => 'white', -textvariable => \$I_channel1 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab2_fin->Entry( -background => 'white', -textvariable => \$I_channel2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab2_fin->Entry( -background => 'white', -textvariable => \$I_channel3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab2_fin->Entry( -background => 'white', -textvariable => \$I_channel4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);

		$tab2_fout->Label( -text => "Output channel settting [0:USB, 1:LSB, 2:Complex, 3:reserve]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab2_fout->Label( -text => "dbbcout ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$tab2_fout->Entry( -background => 'white', -textvariable => \$O_channel1 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab2_fout->Entry( -background => 'white', -textvariable => \$O_channel2 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab2_fout->Entry( -background => 'white', -textvariable => \$O_channel3 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);
		$tab2_fout->Entry( -background => 'white', -textvariable => \$O_channel4 ,-width => 5 )->pack( -side => "left", -anchor => 'nw', -pady => 5);

		$tab2_fvsi->Label( -text => "VSI output format setting", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);
		$tab2_fvsi->Label( -text => "dbbcvsi ")->pack(  -side => "left",-anchor => 'nw', -pady => 5 );
		$opt_format = $tab2_fvsi->Optionmenu(-variable=>\$dbbcvsi, -textvariable=>\$vsi_name)->pack( -side => "left",-anchor => 'nw' );
		$opt_format->addOptions(["0:bit-div-clock-fix"=>0],["1:bit-div-clock-variable"=>1],["2:channel-div-clock-fix"=>2],["3:channel-div-clock-variable"=>3]);

		$tab2_ffreq1->Label( -text => "Frequency setting [MHz]", -relief => 'flat', -background => 'yellow')->pack( -anchor => 'nw' ,-padx => 3,  -pady => 3);

		@entry_Frequency = ();

		for( $r=0; $r<16; $r++) {
		    $entry_Frequency[$r][0] = $tab2_ffreq2->Label( -text => "bbc_d1", -relief => 'ridge',-width => 8);
		    $entry_Frequency[$r][1] = $tab2_ffreq2->Label( -text => "1", -relief => 'ridge',-width => 2);
		    $entry_Frequency[$r][2] = $tab2_ffreq2->Label( -text => $r, -relief => 'ridge',-width => 2);
#		    $entry_Frequency[$r][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency[$r][3], -width => 11 );
		}
		$entry_Frequency[0][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency0, -width => 11 );
		$entry_Frequency[1][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency1, -width => 11 );
		$entry_Frequency[2][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency2, -width => 11 );
		$entry_Frequency[3][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency3, -width => 11 );
		$entry_Frequency[4][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency4, -width => 11 );
		$entry_Frequency[5][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency5, -width => 11 );
		$entry_Frequency[6][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency6, -width => 11 );
		$entry_Frequency[7][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency7, -width => 11 );
		$entry_Frequency[8][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency8, -width => 11 );
		$entry_Frequency[9][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency9, -width => 11 );
		$entry_Frequency[10][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency10, -width => 11 );
		$entry_Frequency[11][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency11, -width => 11 );
		$entry_Frequency[12][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency12, -width => 11 );
		$entry_Frequency[13][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency13, -width => 11 );
		$entry_Frequency[14][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency14, -width => 11 );
		$entry_Frequency[15][3] = $tab2_ffreq2->Entry( -background => 'white', -textvariable => \$Frequency15, -width => 11 );

		
		for( $r=0; $r<16; $r++) {
		    if ($r<8){
				$entry_Frequency[$r][0] ->grid( -row => $r, -column => 0 );
				$entry_Frequency[$r][1] ->grid( -row => $r, -column => 1 );
				$entry_Frequency[$r][2] ->grid( -row => $r, -column => 2 );
				$entry_Frequency[$r][3] ->grid( -row => $r, -column => 3 );
		    }
		    else{
				$entry_Frequency[$r][0] ->grid( -row => $r-8, -column => 4 );
				$entry_Frequency[$r][1] ->grid( -row => $r-8, -column => 5 );
				$entry_Frequency[$r][2] ->grid( -row => $r-8, -column => 6 );
				$entry_Frequency[$r][3] ->grid( -row => $r-8, -column => 7 );
		    }
		}
		
		&ReadData1_0;
		&ReadData1_1;
		&ReadData1_2;
		&ReadData2;
	
	}
}


sub onDispBit{

	my $array;
    my @bithist = ();
    my $i=0;

	$list_bit->configure( -state => 'normal');

	$list_bit->delete( '1.0', 'end' );
    @bithist = $ads->ReadBithist($Bithistch);
    for($i=0; $i<@bithist; $i++){
		$list_bit->insert('end',$bithist[$i]);
    }
	$list_bit->configure( -state => 'disabled');
	    
    ##if ($disp==1){$array = "bit_hist ".$Bithistch."\n";};
    #for($i=0; $i<@bithist; $i++){
	#	#$bithist[$i]=~ s/\s+//g;
	#	#print "$bithist[$i]";
	#	if ($disp==1 && $i==20){last;};
	#	$array = $array . $bithist[$i];
    #}
	#if ($disp==0){
	#	$tab1_fbit2->Message( -text => $array, -relief => 'ridge', -width => 800)->pack( -anchor => 'nw', -pady => 5, -padx => 3);
	#}else{
	#	$tab1_fbit2->destroy();
	#	$tab1_fbit2 = $tab1_1->Frame(-relief => 'flat', -borderwidth => 2);
	#	$tab1_fbit2->pack(-side => "top", -padx => 5, -anchor => 'nw');
	#	$tab1_fbit2->Message( -text => $array, -relief => 'ridge', -width => 800)->pack( -anchor => 'nw', -pady => 5, -padx => 3);
	#}
	#$disp=1;

}

sub onDispReg{

	my $i=0;
    my @regs = ();

	$list_regs->configure( -state => 'normal');

	$list_regs->delete( '1.0', 'end' );
    @regs = $ads->ReadRegs($Regs);
    for($i=0; $i<@regs; $i++){
		$list_regs->insert('end',$regs[$i]);
    }
	$list_regs->configure( -state => 'disabled');
}

sub onReLoad1_0{

	&ReadData1_0;
	

}
sub onReLoad1_1{

	&ReadData1_1;
}

sub onReLoad2{

    &ReadData2;

}

sub onUpdate1_0 {
#check
	chomp($mode1);
	chomp($mode2);
	chomp($mode3);
	chomp($mode4);
	$I_mode=$mode1.$mode2.$mode3.$mode4;
    if ($I_mode !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "mode string input");
        return;
	}elsif (($mode1 < 8) || ($mode1 > 10) || ($mode2 < 8) || ($mode2 > 10) || ($mode3 < 8) || ($mode3 > 10) || ($mode4 < 8) || ($mode4 > 10) ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "mode 10 or 8 or 9");
        return;
    }
    
	chomp($gain1);
	chomp($gain2);
	chomp($gain3);
	chomp($gain4);
	$I_gain=$gain1.$gain2.$gain3.$gain4;
    if ($I_gain !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "gain string input");
        return;
	}elsif (($gain1 < 0) || ($gain1 > 7) || ($gain2 < 0) || ($gain2 > 7) || ($gain3 < 0) || ($gain3 > 7) || ($gain4 < 0) || ($gain4 > 7) ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "gain 0-7");
        return;
    }

    $I_cicgain=$cicgain1.$cicgain2.$cicgain3.$cicgain4;
    chomp($I_cicgain);
    if ($I_cicgain !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcout string input");
        return;
	}elsif($I_cicgain =~ /[4-9]/){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "cicgain 0 or 1 or 2 or 3");
	    return;   
    }
    
    $num1 = length($cicgain1);
    $num2 = length($cicgain2);
    $num3 = length($cicgain3);
    $num4 = length($cicgain4);

    if ($num1!=4 || $num2!=4 || $num3!=4 || $num4!=4 ) {
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "cicgain input error");
        return;}

	if ($pps == 1){
		$ads->Set1pps();
	}

	@mode = ();
	$mode[0]=$mode1;
	$mode[1]=$mode2;
	$mode[2]=$mode3;
	$mode[3]=$mode4;
	for( my $i=0; $i<4; $i++) {
		$ads->SetMode(($i+1),$mode[$i]);
	}

	@offs = ();
	$offs[0]=$offs1;
	$offs[1]=$offs2;
	$offs[2]=$offs3;
	$offs[3]=$offs4;
	for( my $i=0; $i<4; $i++) {
		$temp = sprintf("0X%0X", $offs[$i]);
		$ads->SetOffs(($i+1),$temp);
	}
	
	@gain = ();
	$gain[0]=$gain1;
	$gain[1]=$gain2;
	$gain[2]=$gain3;
	$gain[3]=$gain4;
	for( my $i=0; $i<4; $i++) {
		$ads->SetGain(($i+1),$gain[$i]);
	}

	if ($pdata == 1){
		$ads->SetPdata();
	}
	
	@cicarr=();
    @cicarr = ($cicgain1,$cicgain2,$cicgain3,$cicgain4);
	$ads->SetCicgain(@cicarr);
	
	@bbcgain=();
	push(@bbcgain,$bbcgain1);push(@bbcgain,$bbcgain2);push(@bbcgain,$bbcgain3);push(@bbcgain,$bbcgain4);push(@bbcgain,$bbcgain5);push(@bbcgain,$bbcgain6);push(@bbcgain,$bbcgain7);push(@bbcgain,$bbcgain8);
	push(@bbcgain,$bbcgain9);push(@bbcgain,$bbcgain10);push(@bbcgain,$bbcgain11);push(@bbcgain,$bbcgain12);push(@bbcgain,$bbcgain13);push(@bbcgain,$bbcgain14);push(@bbcgain,$bbcgain15);;push(@bbcgain,$bbcgain16);
	$ads->SetBbcgain(@bbcgain);

	if ($mode_vsisel == 1){
		$ads->Setvsisel();
	}
	
    $mw->messageBox(
		-type => "ok",
		-icon => "info",
		-title => "ADS3000plus setting",
		-message => "Update succeed !!");
}

sub onUpdate1_1 {

    if ($adcoffs !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "adcoffs string input");
        return;
	}
	
    if ($adcgain !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "adcgain string input");
        return;
	}

	$ads->SetAdcchsel($adcchsel);
	$temp = sprintf("0X%0X", $adcoffs);
	$ads->SetAdcoffs($temp);
	$temp = sprintf("0X%0X", $adcgain);
	$ads->SetAdcgain($temp);

    $mw->messageBox(
		-type => "ok",
		-icon => "info",
		-title => "ADS3000plus setting",
		-message => "Update succeed !!");

}

sub onUpdate2 {
#check
    $I_channel=$I_channel1.$I_channel2.$I_channel3.$I_channel4;
    chomp($I_channel);
    $O_channel=$O_channel1.$O_channel2.$O_channel3.$O_channel4;
    chomp($O_channel);

    if ($I_channel !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcin string input");
        return;
    }elsif($I_channel =~ /[4-9]/){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcin 0 or 1 or 2 or 3");
	    return;
    }

    if ($O_channel !~/^\d+$/ ){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcout string input");
        return;
    }elsif($O_channel =~ /[4-9]/){
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcout 0 or 1 or 2 or 3");
	    return;
    }

    $num1 = length($I_channel1);
    $num2 = length($I_channel2);
    $num3 = length($I_channel3);
    $num4 = length($I_channel4);

    if ($num1!=4 || $num2!=4 || $num3!=4 || $num4!=4 ) {
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcin input error");
        return;}
    
    $num1 = length($O_channel1);
    $num2 = length($O_channel2);
    $num3 = length($O_channel3);
    $num4 = length($O_channel4);

    if ($num1!=4 || $num2!=4 || $num3!=4 || $num4!=4 ) {
	$mw->messageBox(
	    -type => "ok",
	    -icon => "warning",
	    -title => "ADS3000plus setting input",
	    -message => "dbbcout input error");
        return;}
        
	# commentout 2014/8/5
    #$I_Frequency=$Frequency0.$Frequency1.$Frequency2.$Frequency3.$Frequency4.$Frequency5.$Frequency6.$Frequency7.$Frequency8.$Frequency9.$Frequency10.$Frequency11.$Frequency12.$Frequency13.$Frequency14.$Frequency15;
    #chomp($I_Frequency);
    #if ($I_Frequency !~/^\d+$/ ){
	#$mw->messageBox(
	#    -type => "ok",
	#    -icon => "warning",
	#    -title => "ADS3000plus setting input",
	#    -message => "Frequency string input");
    #    return;
    #}
    
    #for( $r=0; $r<16; $r++) {
	#	chomp($Frequency[$r][3]);
	#	if ($Frequency[$r][3] !~/^\d+(?:\.\d+)?$/ ){
	#	    print "$Frequency[$r][3]\n";
	#	    $top->messageBox(
	#	        -type => "ok",
	#	        -icon => "warning",
	#	        -title => "ADS3000plus setting input",
	#	        -message => "Frequency string input");
	#	    return;
	#	}
    #}

    my @ifarr;
    my @outarr;
    @ifarr = ($I_channel1,$I_channel2,$I_channel3,$I_channel4);
    @outarr = ($O_channel1,$O_channel2,$O_channel3,$O_channel4);


    my @recs;
    @recs = ();
    #for( $i=0; $i<16; $i++) {
	#	$temp = sprintf("0X%0X", ($Frequency[$i][3] * 1.e6));
	$temp = sprintf("0X%0X", ($Frequency0 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency1 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency2 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency3 * 1.e6));push(@recs,$temp);
	$temp = sprintf("0X%0X", ($Frequency4 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency5 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency6 * 1.e6));push(@recs,$temp);
	$temp = sprintf("0X%0X", ($Frequency7 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency8 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency9 * 1.e6));push(@recs,$temp);
	$temp = sprintf("0X%0X", ($Frequency10 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency11 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency12 * 1.e6));push(@recs,$temp);
	$temp = sprintf("0X%0X", ($Frequency13 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency14 * 1.e6));push(@recs,$temp);$temp = sprintf("0X%0X", ($Frequency15 * 1.e6));push(@recs,$temp);
	#push(@recs,$temp);
    #}

    $ads->SetBW($Bandwidth);
    $ads->SetIFin(@ifarr);
    $ads->SetULSB(@outarr);
    $ads->SetVsi($dbbcvsi);
    $ads->SetLo_2(@recs);

    $mw->messageBox(
		-type => "ok",
		-icon => "info",
		-title => "ADS3000plus setting",
		-message => "Update succeed !!");

}


